// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

#include "general.h"
#include "autocrte.h"
#include "config.h"
#include "dirfile.h"

struct sAutoarea autoarea[AUTOAREA];

void tpl2str(       // <- autocreate, areamgr.local2areas   
    char *p1,       // autoarea[group].area
    char *p2,       // templine[CONFIGLINE]
    char *tag )     // in.area
{
    int i = 0;
    while( *++p1 )
    {
        if( *p1 == '%' )     // if macro
        {
            ++p1;
            if( *p1 == 'T' ) strcpy( p2, tag );
            else if( toupper( *p1 ) == 'D' )
            {
                while( *tag && ( *p1 == 'd' || i < 8 ) )
                    if( *tag++ != '.' ) p2[i++] = *( tag - 1 );
                p2[i] = 0;
                while( !isspace( *p2 ) ) --p2;
                dirfull( ++p2 );
                LASTCHAR( p2 ) = 0;
                if( !access( p2, F_OK ) )   // file or directory exists
                {
                    strcat( p2, ".0" );
                    while( !access( p2, F_OK ) ) LASTCHAR( p2 )++;
                }
                strcat( p2, "\\" );
            }
            p2 = strchr( p2, 0 );
        }
        else *p2++ = *p1;   // not macro
    }
    *p2 = 0;
}

void loadauto   // load Auto* lines from filin.ctl
    (char *l)   // configuration line
// <- load_config.config
// -> errexit.general strchr isupper alloc strcpy
{
    static int group;   // saves area for recv/send
    char *pGroup;
    switch (l[4])
    {
        case 'A': case 'a': 
            // AutoArea: search group -> check if correct -> load AutoArea
            if (pGroup = strchr(l,'$'))
            {
                if (!isupper(group = *(pGroup+1))) errexit(8,l);
                group = group-'A'+1;    // A = 1, Z = 26
            }
            else
                group = 0;                      // No group = 0
            if (!autoarea[group].area)          // 1st time?
                autoarea[group].area = (char*) malloc(CONFIGLINE);
            strcpy(autoarea[group].area,l+4);
            break;
        case 'R': case 'r':
            if (autoarea[group].area)           // Area defined?
            {
                if (!autoarea[group].recv)     // 1st time?
                    autoarea[group].recv = (char*) malloc(CONFIGLINE);
                strcpy(autoarea[group].recv,l+4);
            }
            break;
        case 'S': case 's':
            if (autoarea[group].area)           // Area defined?
            {
                if (!autoarea[group].send)     // 1st time?
                    autoarea[group].send = (char*) malloc(CONFIGLINE);
                strcpy(autoarea[group].send,l+4);
            }
            break;
    }
}

// --- return -1 if no template for autocreation
int getgroup(
    struct  Slink *Ltemp )
{
    int group = 0;
// --- get group or leave default (0)
    if( *Ltemp->groups )
        if( !autoarea[group = *Ltemp->groups-'A'+1].area )
            if( !autoarea[group = 0].area ) return -1;
    return group;
}    

struct Sarea *autocreate    // create area in memory using Auto* info
    (struct Slink *Ltemp)   // sender
{
    char templine[CONFIGLINE];
    int i, group;
    struct Sarea *Atemp;        // to return
    if( ( group = getgroup( Ltemp ) ) == -1 ) return NULL;
    tpl2str( autoarea[group].area, templine, in.area );
    Atemp = parsearea(templine);
// --- ReceiveFrom: AutoReceiveFrom (+Sender), SendTo: AutoSendTo
    parseupdown(autoarea[group].recv,Atemp,0);
    for (i = 0; i < num_of_links; i++)
    {
        if (Atemp->uplink[i] == NULL) Atemp->uplink[i] = Ltemp;
        if (Atemp->uplink[i] == Ltemp) break;
    }
    parseupdown(autoarea[group].send,Atemp,1);
    if( Atemp->bidirect && Ltemp->bidirect )
    {
        for( i = 0; Atemp->downlink[i] && Atemp->downlink[i] != Ltemp; ++i );
        Atemp->downlink[i] = Ltemp;
    }
// --- autocreating finished
    save_areas();
    logout(stdout,'+',"Area %s autocreated",Atemp->tag);
    autoreport(Atemp->tag,addrtostr(&Ltemp->addr));
    return Atemp;
}
