// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

//  ᫮!
// 14 Oct 95

// Do it simple, do it reliable
// And only then do it flexible

#include <direct.h>
#include "general.h"
#include "config.h"
#include "areamgr.h"
#include "tic.h"
#include "dirfile.h"
#include "index.h"
#include "descript.h"
#include "autocrte.h"
#include "purge.h"
#include "outbound.h"
#include "fidomsg.h"

#ifdef __NT__
#include "w32.h"
#endif

#ifdef __NT__
char* title = "FILin/W32 1.3 Release Fix";
#else
char* title = "FILin/OS2 1.3 Release Fix";
#endif
char* copyright = "(c) Copyright 1995-99 Ilja Bogdanov";

struct sAddr la;
struct sAddr address[AKA];
char filedir[DIRLEN];
char *inbound[FILEDIR];
char ticsdir[DIRLEN];
int ticsdays;
char outdir[DIRLEN];
char outmaildir[DIRLEN];
char inmaildir[DIRLEN];
char aliasfile[PATHLEN];
int mgropt;
FILE* log;
int loglevel;
struct Sarea* areas;
struct Slink* links;
int num_of_links;
char rqfull[PATHLEN];
//char autoarea[CONFIGLINE];
//char autouplinks[CONFIGLINE];
//char autodownlinks[CONFIGLINE];
char aliases[CONFIGLINE] = "FILIN ";
char outb[DIRLEN] = "OUTBOUND\\";
int outshort;
char dupedir[DIRLEN] = "DUPES\\";
char* nftpl;
long nfsize;
struct Slink** seenby;
char ticfull[PATHLEN];
struct Sin in;
char dlc[DLC];
int postsw;
char postnfr[PATHLEN];
char postdir[DIRLEN];
char newarea[PATHLEN];
char newfile[PATHLEN];
char mgrpass[PASSLEN];

enum{ FILES = 1, MGR, HATCH, PURGE, POST } runmode;
enum DUPEOPT dupeopt;
enum OUTBOUND outtype;

static int fTakedesc;   // 1 if desc is taken from files.bbs during HATCH

void outbound (struct Sarea* Parea, struct Slink* Pdown, char* filein)
{
  char createdir[DIRLEN], ticfile[13], ticreate[PATHLEN], *line,
       seenbyline[7+ADDRLEN];
//  struct Smsghdr msghdr;
    struct sMsg msg;
  FILE* tic;
  int seen=0,i,j;
  time_t t;
  if (outtype==1)           // FileBox
  {
    if (!createbox(createdir,&Pdown->addr,Pdown->hold))
       {logout(stdout,'?',"Cannot create filebox %s",createdir); return;}
  }
  else strcpy(createdir,outb);
  sprintf(ticfile,"fi%03x%03x.tic",rand()%0x1000,rand()%0x1000);
  while ((tic=fopen(filefull(ticreate,createdir,ticfile),"r"))!=NULL)
  {                         // if such tic exists create the new one
    fclose(tic);
    sprintf(ticfile,"fi%03x%03x.tic",rand()%0x1000,rand()%0x1000);
  }
  if ((tic=fopen(ticreate,"wt"))==NULL)
     {logout(stdout,'?',"Cannot open file %s",ticreate); return;}
  fprintf(tic,"Created by %s %s\n",title,copyright);
  fprintf(tic,"From %s\n",addrtostr(&la));
  fprintf(tic,"To %s\n",addrtostr(&Pdown->addr));
  fprintf(tic,"Pw %s\n",Pdown->pass);
  newget=1;                 // get tic lines from the beginning
  while ((line=getticline())!=NULL)
  {
    if (!strnicmp(line,"Seenby ",7))
       {
       if (!seen)
          {
          time(&t);
          fprintf(tic,"Path %s %ld %s",addrtostr(&la),t,ctime(&t));
          sprintf(seenbyline,"Seenby %s",addrtostr(&la));
          fprintf(tic,"%s\n",seenbyline);
          for (i=0;Parea->downlink[i]&&i<num_of_links;i++)
          {                     // put downlinks in seenby lines
            for (j=0;Parea->downlink[i]!=seenby[j]&&seenby[j];j++);
            if (!seenby[j])     // only those which were not seenby before
              fprintf(tic,"Seenby %s\n",addrtostr(&Parea->downlink[i]->addr));
          }
          seen=1;               // all seenby lines were put
          }
       if (strnicmp(line,seenbyline,strlen(seenbyline))) // do not double
          fputs(line,tic);                               // Seenby <la>
       }
    else fputs(line,tic);
  }
  fclose(tic);
    if( outtype == BOX ) copyfile( filein, createdir );
#ifdef __NT__
    else if( outshort )
    {
        shortpath( filein );
        shortpath( ticreate );        
    }
#endif    
    if( outtype == AMA )
    {
        msg.from = la;
        msg.to = Pdown->addr;
        strcpy( msg.fromname, "FILin" );
        strcpy( msg.toname, "SysOp" );
        msg.isatt = 1;
        msg.iskil = 1;
        msg.isdir = 1;
        msg.ishld = Pdown->hold;
        msg.text = ( char * ) calloc( 1, 1 );
        if( strlen( filein ) > 71 || strlen( ticreate ) > 71 )
            { logout( stdout, '?', "Attach of %s failed", filein ); return; }
        strcpy( msg.subj, filein );
        msg.iskfs = 0;
        if( writemsg( outdir, &msg ) == -1 )
            { logout( stdout, '?', "Attach of %s failed", filein ); return; }
        strcpy( msg.subj, ticreate );
        msg.iskfs = 1;
        if( writemsg( outdir, &msg ) == -1 )
            { logout( stdout, '?', "Attach of %s failed", ticreate ); return; }
        free( msg.text );
    }
    if( outtype == BSO ) makebink(&Pdown->addr,Pdown->hold,filein,ticreate);
  logout(NULL,'*',"Sent to %s",addrtostr(&Pdown->addr));
}

void replacefiles (char* areadir, char* replfile, int del)
{
  struct find_t f;
  FILE* fbbs,
      * fbbs1;
  char filesbbs[PATHLEN], filesbbs1[PATHLEN], line[CONFIGLINE],
       temp[FILELEN], temp1[FILELEN],
       *rplfiles, replfull[PATHLEN],
       validname[] = "!#$%&'()-@^_`{}~";
  int k,
      i = 0;

  k = _dos_findfirst(filefull(replfull,areadir,replfile),_A_NORMAL,&f);
  while (!k) {
    i++;
    k = _dos_findnext(&f);
  }
  _dos_findclose(&f);

  if (!i) return;
  if ((rplfiles = (char*)calloc(i,FILELEN)) == NULL) errexit(3,"rplfiles");

  k = _dos_findfirst(replfull,_A_NORMAL,&f);
  while (!k) {
    if( del != 2 || stricmp( in.file, f.name ) )    // if Replaces don't touch in.file
    {
        strcat(rplfiles,f.name);
        strcat(rplfiles," ");
        if (del) unlink(filefull(replfull,areadir,f.name));
    }
    k = _dos_findnext(&f);
  }
  _dos_findclose(&f);

  fbbs1 = fopen(filefull(filesbbs1,areadir,"files.bb$"),"wt");
  if ((fbbs = fopen(filefull(filesbbs,areadir,"files.bbs"),"rt")) != NULL) {
    while (fgets(line, CONFIGLINE, fbbs) != NULL) {
NEXT: wordcpy(temp,line,FILELEN);
      for (k = 0;
           k < i && stricmp(temp,wordcpy(temp1,word(rplfiles,k),FILELEN));
           k++);
      if (k == i) fputs(line,fbbs1);
      else while (fgets(line, CONFIGLINE, fbbs) != NULL)
        if (isalnum(*line) || strchr(validname,*line)) goto NEXT;
    }
    fclose(fbbs);
  }
  fclose(fbbs1);
  unlink(filesbbs);
  rename(filesbbs1,filesbbs);
}

void nfreport (char* areadesc)
{
  FILE* Ftxt;
  int i;
  char size[25];

  if (nftpl != NULL && *newfile != 0) {
    if ((Ftxt = fopen(newfile,"ab")) == NULL)
      logout(stdout,'?',"Report failed");
    else {
      for (i = 0; i < nfsize; i++)
        if (nftpl[i] == '@') {
          if (nftpl[++i] == 'A') fputs(in.area,Ftxt);
          else if (nftpl[i] == 'F') fputs(in.file,Ftxt);
          else if (nftpl[i] == 'S') fputs(ltoa(in.size,size,10),Ftxt);
          else if (nftpl[i] == 'D') fputs((in.desc)?in.desc:"Unknown",Ftxt);
          else if (nftpl[i] == 'E') fputs((*areadesc)?areadesc:"Unknown",Ftxt);
          else if (nftpl[i] == 'L') fputs(addrtostr(&in.from),Ftxt);
          else if (nftpl[i] == 'O') fputs((*in.origin)?in.origin:"Unknown",Ftxt);
//          else if (nftpl[i] == 'T') fputs(title,Ftxt);
          else {
            fputc('@',Ftxt);
            fputc(nftpl[i],Ftxt);
          }
        }
        else fputc(nftpl[i],Ftxt);
      fclose(Ftxt);
    }
  }
}

#define ALIASLINE 256
void magicupdate (char* magicname, char* filein)
{
  FILE* Fold,* Fnew;
  char aliascopy[PATHLEN], line[ALIASLINE],* l, line2[ALIASLINE], alias[MAGICLEN];
  struct find_t f;
  int update;

  if (!_dos_findfirst(aliasfile,_A_NORMAL,&f))
  {
    strcpy(aliascopy,aliasfile);
    if (aliascopy[strlen(aliascopy)-1] != '$')
      aliascopy[strlen(aliascopy)-1] = '$';
    else
      aliascopy[strlen(aliascopy)-1] = '#';
    rename(aliasfile,aliascopy);
    if ((Fold = fopen(aliascopy,"rt")) != NULL && (Fnew = fopen(aliasfile,"wt")) != NULL)
    {
      update = 0;
      while (fgets(line,ALIASLINE,Fold) != NULL)
      {
        l = line;
        while (isspace(*l)) l++;
        wordcpy(alias,l,MAGICLEN);
        if (!update && !stricmp(alias,magicname))
        {
          l = word(line,1);
          strncpy(line2,line,l-line);
          line2[l-line] = '\0';
          strcat(line2,filein);
          while (!isspace(*l)) l++;
          strncat(line2,l,ALIASLINE-strlen(line2)-1);
          fputs(line2,Fnew);
          update = 1;
        }
        else fputs(line,Fnew);
      }
      if (!update) fprintf(Fnew,"%-8s %s\n",magicname,filein);
      fclose(Fnew);
      fclose(Fold);
      unlink(aliascopy);
      logout(NULL,'*',"FReq alias file updated");
      return;
    }
  }
  else if ((Fnew = fopen(aliasfile,"wt")) != NULL)
  {
    fprintf(Fnew,"%-8s %s\n",magicname,filein);
    fclose(Fnew);
    logout(NULL,'*',"FReq alias file updated");
    return;
  }
  _dos_findclose(&f);
  logout(stdout,'?',"Cannot update alias file");
}

void doit(
    struct Sarea*   Atemp,
    char*           filein )
{
    int             j, k;
    char            templine[PATHLEN];
    if( !ISPASSTHRU( Atemp ) )
    {
        if( Atemp->replace ) replacefiles( Atemp->dir, in.repl, 2 );
        if( runmode == HATCH )
        {
            if( in.desc && !fTakedesc )   // don't delete old file (copy)
                replacefiles( Atemp->dir, in.file, 0 );
        }
        else
            if( in.desc )                 // delete old file (move)
                replacefiles( Atemp->dir, in.file, 1 ); 
            else
                unlink( filefull( templine, Atemp->dir, in.file ) );
        if( runmode != HATCH || !fTakedesc ) movedesc( Atemp->dir );
        if( runmode == HATCH )
            copyfile( filein, Atemp->dir );
        else
            movefile( filein, Atemp->dir );
        filefull( filein, Atemp->dir, in.file );
        logout( NULL, '*', "Tossed" );
        if( *aliasfile && Atemp->magic && *in.magic )
            magicupdate( in.magic, filein );
    }
    else
    {
        if( runmode == HATCH )
            copyfile( filein, outb );
        else
            movefile( filein, outb );
        filefull( filein, outb, in.file );
    }
    addindex();
    if (*ticsdir) movefile(ticfull,ticsdir);
    else unlink(ticfull);

  if (Atemp->downlink[0] && !outtype) 
        logout(stdout,'?',"Outbound not defined");
  for (j = 0; Atemp->downlink[j] && j < num_of_links; j++)
  {
    if (Atemp->passive[j]) continue;
    for (k = 0; Atemp->downlink[j] != seenby[k] && seenby[k]; k++);
    if (!seenby[k]) outbound(Atemp,Atemp->downlink[j],filein);
  }

  if( ISPASSTHRU( Atemp ) && outtype == BOX ) unlink(filein);   // moved to boxes
  nfreport(Atemp->desc);
}

void autoreport (char* atA, char* atU)
{
  FILE* Frpt,
      * Ftxt;
  int ch;

  if (*newarea == 0) return;
  if ((Frpt = fopen("newarea.rpt","rt")) == NULL ||
      (Ftxt = fopen(newarea,"at")) == NULL)
  {
    logout(stdout,'?',"Report failed");
    return;
  }
  while ((ch = fgetc(Frpt)) != EOF)
    if (ch == '@') {
      if ((ch = fgetc(Frpt)) == 'A') fputs(atA,Ftxt);
      else if (ch == 'U') fputs(atU,Ftxt);
//      else if (ch == 'T') fputs(title,Ftxt);
      else {
        fputc('@',Ftxt);
        fputc(ch,Ftxt);
      }
    }
    else fputc(ch,Ftxt);
  fclose(Ftxt);
  fclose(Frpt);
}


void checkit( void )
{
  char filein[PATHLEN], temp[9];
  struct stat   st;
  struct Sarea* Atemp;
  struct Slink* Ltemp;
  int j;

  logout(stdout,0,"  %-12s in %s (%s)",in.file,in.area,addrtostr(&in.from));
    if( stat( filefull( filein, filedir, in.file ), &st ) )
    {
        logout(stdout,'?',"No such file");
        return;
    }
  if (in.size) {
    if (st.st_size != in.size) {
      logout(stdout,'?',"Size mismatch");
      return;
    }
  }
  else in.size = st.st_size;
  if ((Ltemp = islink(&in.from)) == NULL) {
    logout(stdout,'?',"Not from a valid Link");
    return;
  }
  sprintf(temp,"%08lX",crcvalue(filein));
  if (*in.crc)
  {
    if ( atol( in.crc ) != atol( temp ) )
    {
      logout(stdout,'?',"Incorrect CRC value (%s instead of %s)",in.crc,temp);
      if (Ltemp->crc) return;
    }
  }
  else strcpy(in.crc,temp);
  if (stricmp(Ltemp->pass,in.pass)) {
    logout(stdout,'?',"Invalid password: %s",in.pass);
    return;
  }
    if( !( Atemp = isarea( in.area ) ) && ( !Ltemp->autocr || !( Atemp = autocreate( Ltemp ) ) ) )
    {   
        logout(stdout,'?',"Area not defined: %s",in.area);
        return;
    }

  memcpy(&la,&address[Atemp->aka],SADDR);
  for (j = 0; j < num_of_links && Atemp->uplink[j] != NULL && Atemp->uplink[j] != Ltemp; j++);
  if (Atemp->uplink[j] != Ltemp) {
    logout(stdout,'?',"Not from a valid uplink: %s",addrtostr(&in.from));
    return;
  }
  if (!dupecheck())
     {
     logout(stdout,'?',"Dupe catched");
     switch (dupeopt)
        {
        case MOVE: if (!makexist(dupedir)) errexit(2,dupedir);
                   movefile(filein,dupedir);
                   movefile(ticfull,dupedir);
                   break;
        case KILL: unlink(filein);
                   unlink(ticfull);
                   break;
        case FORCE: goto IGNORE;
        }
     return;    // if commented, or Move, or Kill
     }
IGNORE:
  doit(Atemp,filein);
}


void hatch(
    char            *filein )
{
    struct stat     st;
    struct Sarea    *Atemp;
    char            h_file[PATHLEN], temp[TICLINE], *Pchar;
    if( !outtype ) errexit( 0, "Outbound not defined" );
    strncpy( h_file, filein, PATHLEN );
    if( strchr( h_file, '?' ) || strchr( h_file, '*' ) )    // no wildcards
        errexit( 1, h_file );
    logout( stdout, 0, "  %s", strupr( h_file ) );
    if( ( Atemp = isarea( strupr( in.area ) ) ) == NULL )
    {
        logout( stdout, '?', "Unknown area: %s", in.area );
        return;
    }
    if( Pchar = strrchr( h_file, '\\' ) )  // the path is present
        strcpy( in.file, Pchar + 1 );
    else                                   // the path is NOT present
    {
        strcpy( in.file, h_file );
        filefull( h_file, Atemp->dir, in.file );
    }
    if( stat( h_file, &st ) ) errexit( 1, h_file );
    in.from = la = address[Atemp->aka];
    in.size = st.st_size;
    sprintf( in.crc, "%08lX", crcvalue( h_file ) );
    logout( stdout, 0, "  %-12s in %s (%s)", in.file, in.area,
        addrtostr( &in.from ) );
  newtic = 1;
  sprintf(temp,"Area %s\n",in.area);
  putticline(temp);
  logout(NULL,'*',temp);
  sprintf(temp,"File %s\n",in.file);
  putticline(temp);
  logout(NULL,'*',temp);
  if (fTakedesc = !in.desc)       // if no desc then get from files.bbs
    takedesc(Atemp->dir,in.file); 
  if (in.desc)
     {
     sprintf(temp,"Desc %s\n",in.desc);
     putticline(temp);
     logout(NULL,'*',temp);
     }
  sprintf(temp,"Size %ld\n",in.size);
  putticline(temp);
  logout(NULL,'*',temp);
  sprintf(temp,"Crc %08lX\n",crcvalue(h_file));
  putticline(temp);
  logout(NULL,'*',temp);
  if (*in.magic)
  {
    sprintf(temp,"Magic %s\n",strupr(in.magic));
    putticline(temp);
    logout(NULL,'*',temp);
  }
  if (*in.repl)
  {
    sprintf(temp,"Replaces %s\n",strupr(in.repl));
    putticline(temp);
    logout(NULL,'*',temp);
  }
  strncpy(in.origin,addrtostr(&la),ADDRLEN);
  sprintf(temp,"Origin %s\n",in.origin);
  putticline(temp);
  logout(NULL,'*',temp);
  sprintf(temp,"Seenby %s\n",addrtostr(&la));
  putticline(temp);
  seenby[0] = islink(&la);
  ticsdir[0] = 0;
  dupecheck();                  // to use addindex()
  doit(Atemp,h_file);
}

void comhat (int argc, char* argv[])
{
  int i = 4;
  if (argc < 4) errexit(0,"Not enough parameters for hatching");
  strncpy(in.area,argv[2],TAGLEN);
  for (; i < argc; i++)
  {
    if (*argv[i] == '!') strncpy(in.magic,argv[i]+1,MAGICLEN);
    else if (*argv[i] == '#') strncpy(in.repl,argv[i]+1,FILELEN);
    else if (!in.desc)
    {
      in.desc = (char*)calloc(strlen(argv[i])+1,1);
#ifdef __NT__
        win2dos( argv[i] );
#endif
      strcpy(in.desc,argv[i]);
    }
  }
  hatch(argv[3]);
}

void post( void )
{
    struct sMsg msg;
    char *nfrep;
    if( !makexist( postdir ) ) errexit( 2, postdir );
    makemsg( &msg );
    msg.from = address[0];
    msg.to = address[0];
    if( postsw & 1 && !access( newarea, R_OK ) )
    {
        logout( stdout, 0, "  New areas report: %s", newarea );
        strcpy( msg.subj, "New areas report" );
        if( msgtext( &msg, newarea ) == -1 || writemsg( postdir, &msg ) == -1 )
            logout( stdout, '?', "Posting failed" );
        else
        {
            logout( stdout, '*', "Posted" );
            unlink( newarea );
        }
    }
    if( postsw & 2 && !access( nfrep = ( *postnfr ) ? postnfr : newfile, R_OK ) )
    {
        logout( stdout, 0, "  New files report: %s", nfrep );
        strcpy( msg.subj, "New files report" );
        if( msgtext( &msg, nfrep ) == -1 || writemsg( postdir, &msg ) == -1 )
            logout( stdout, '?', "Posting failed" );
        else
        {
            logout( stdout, '*', "Posted" );
            unlink( nfrep );
        }
    }
}

void usage (void)
{
    printf("\n\n%s\n\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n\t%s\n",
//#if defined(OS_2)
//           "Usage: filin-2.exe <command>",
//#elif defined(WIN32)
//           "Usage: filin32.exe <command>",
//#else
           "Usage: filin.exe <command>",
//#endif
           "<command> is one of the following:",
           "  FILES -- to process inbound files",
           "  MGR   -- to run AreaManager",
           "  PURGE -- to purge sent passthru files",
           "  POST  -- to post reports into MSG",
           "  HATCH <areatag> <filename> [\"<description>\"] [!<magicname>] [#<replaces>]",
           "  HATCH @<section>",
                   "-- to hatch file into fileecho");
}

void main(
    int             argc,
    char*           argv[] )
{
    struct find_t   f;
    struct stat     st;
    int             done, k = 0;
    FILE*           newfilerpt;
    char            drive[DIRLEN], dir[DIRLEN];
    printf( "\n\nĴ %s %s", title, copyright );
    _splitpath( argv[0], drive, dir, NULL, NULL );
    chdir( strcat( drive, dir ) );
    load_config();
    logout( NULL, 0, "Ĵ %s %s" , title, copyright );
    load_areas();
    srand( time( NULL ) );
    if( argc > 1 )
        if( !stricmp( argv[1], "FILES" ) ) runmode = FILES;
        else if( !stricmp( argv[1], "MGR" ) ) runmode = MGR;
        else if( !stricmp( argv[1], "HATCH" ) ) runmode = HATCH;
        else if( !stricmp( argv[1], "PURGE" ) ) runmode = PURGE;
        else if( !stricmp( argv[1], "POST" ) ) runmode = POST;
    if( runmode == FILES || runmode == HATCH )
    {
        if( !stat( "newfile.rpt", &st ) )
        {
            nftpl = ( char * ) calloc( 1, nfsize = st.st_size );
            newfilerpt = fopen( "newfile.rpt", "rb" );
            fread( nftpl, nfsize, 1, newfilerpt );
            fclose( newfilerpt );
        }
    }
    if( runmode == FILES || runmode == MGR || runmode == HATCH ) loadindex();
    if( runmode == POST )
    {
//      if( !*inmaildir ) errexit( 0, "AreaMgrDir is not defined" );
        if( postsw && *postdir )
        {
            logout( stdout, 0, "Ĵ POST" );
            logout( stdout, 0, " " );
            post();
        }
        else errexit( 0, "PostDir is not defined or nothing to post" );
    }
    else if( runmode == PURGE )
    {
        logout( stdout, 0, "Ĵ PURGE" );
        logout( stdout, 0, " " );
        purge();
    }
    else if( runmode == HATCH )
    {
        logout( stdout, 0, "Ĵ HATCH" );
        logout( stdout, 0, " " );
        if( argc == 2 ) usage();
        else if( *argv[2] == '@' ) loadhat( argv[2] + 1 );
        else comhat( argc, argv );
    }
    else if( runmode == MGR )
    {
        if( !*inmaildir ) errexit( 0, "AreaMgrDir is not defined" );
        logout( stdout, 0, "Ĵ MGR" );
        logout( stdout, 0, " " );
        done = _dos_findfirst( filefull( rqfull, inmaildir, "*.msg" ), _A_NORMAL, &f );
        while( !done )
        {
            filefull( rqfull, inmaildir, f.name );
            areamgr( rqfull );
            done = _dos_findnext( &f );
        }
        _dos_findclose( &f );
        killorphans();
    }
    else if( runmode == FILES )
    {
        if ( !*filedir ) errexit( 0, "FileDir is not defined" );
        logout( stdout, 0, "Ĵ FILES" );
        logout( stdout, 0, " " );
        do
        {
            if( !makexist( filedir ) )
            {
                logout( stdout, '?', "FileDir %s cannot be accessed", filedir );
                continue;
            }
            done = _dos_findfirst( filefull( ticfull, filedir, "*.tic" ),
                _A_NORMAL, &f );
            while( !done )
            {
                filefull( ticfull, filedir, f.name );
                load_tic();
                checkit();
                done = _dos_findnext( &f );
            }
            _dos_findclose(&f);
        }
        while( ++k < FILEDIR && inbound[k] && *strcpy( filedir, inbound[k] ) );
    }
    else usage();
    if( runmode == FILES || runmode == MGR || runmode == HATCH ) closeindex();
    logout( stdout, 0, " " );
    logout( stdout, 0, "Ĵ The END" );
}
