// This is the header file of functions, types and variables used by FILin
// (c) Copyright 1995-99 Ilya Bogdanov
// All rigths reserved

#ifndef GENERAL_H
#define GENERAL_H

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <io.h>

#include "fidoaddr.h"

#define DIRLEN     248  //(MAXPATH-12)
#define FILELEN    256  //MAXFILE
#define PATHLEN    260  //MAXPATH
#define CONFIGLINE 1024
#define TAGLEN     31
#define PASSLEN    11
#define GROUPSLEN  27
#define DESCLEN    51
#define AKA        10
#define MAGICLEN   9
#define DLC        8
#define FILEDIR    5
#define LOCALADDR  10

enum boolean {false,true};

struct Slink
{
  struct sAddr addr;
  char pass[PASSLEN];
  char groups[GROUPSLEN];
  struct Slink* next;
  enum boolean autocr;
  enum boolean hold;
  int crc;
  int bidirect;
  int days;
  int forward;
  char  *arealist;
};

struct Sarea
{
  char tag[TAGLEN];
  char dir[DIRLEN];
  enum boolean replace;
  int magic;
  int bidirect;
  char group;
  int aka;
//  int passthru;
  struct Slink** uplink;
  struct Slink** downlink;
  int *passive;
  char desc[DESCLEN];
  struct Sarea* next;
};

struct Smsghdr {
  char fromname[36],toname[36],subj[72],datetime[20];
  unsigned short timesread,tonode,fromnode,cost;
  unsigned short fromnet,tonet;
  unsigned short tozone,fromzone,topoint,frompoint;
  unsigned short replyto,flags,nextreply;
};

struct Sin
{
  char area[TAGLEN];
  char file[FILELEN];
  struct sAddr from;
  struct sAddr to;
  char pass[PASSLEN];
  long size;
  char crc[9];
  char magic[MAGICLEN];
  char repl[FILELEN];
  char origin[ADDRLEN];
  char* desc;
};

struct Sndx
{
  char file[13];
  char area[TAGLEN];
  char crc[9];
};
extern struct Sndx *index;

extern struct Sin in;
extern struct sAddr la;
extern struct sAddr address[];
extern char filedir[];
extern char *inbound[];
extern char ticsdir[];
extern int ticsdays;
//extern int outtype;
extern char outdir[];
extern char inmaildir[];
extern char outmaildir[];
extern int mgropt;
extern struct Sarea* areas;
extern struct Slink* links;
extern char* title;
extern FILE* log;
extern int loglevel;
extern char rqfull[];
extern char aliasfile[];
extern int num_of_links;
//extern char autoarea[];
//extern char autouplinks[];
//extern char autodownlinks[];
extern char aliases[];
extern char outb[];
extern int outshort;
extern char ticfull[];
extern struct Slink** seenby;
extern int newget;
extern int newtic;
extern char dlc[DLC];
extern int postsw;
extern char postnfr[];
extern char postdir[];
extern char newarea[];
extern char newfile[];
extern char mgrpass[];

//--- enum types & variables

enum DUPEOPT {LEAVE, MOVE, KILL, FORCE};
extern enum DUPEOPT dupeopt;

enum OUTBOUND {BOX=1,AMA,BSO};
extern enum OUTBOUND outtype;

//--- Macros

#define LASTCHAR( s ) ( *( strchr( s, 0 ) - 1 ) )
//#define LASTCHAR(s) s[strlen(s)-1]
#define NEW(s)  ( ( s * ) calloc( 1, sizeof( s ) ) )
#define ISPASSTHRU( s )   ( !*s->dir )

//--- External functions

extern void autoreport (char* atA, char* atU);  // filin.c

extern void outbound (struct Sarea* Parea, struct Slink* Pdown, char* filein);

extern void hatch (char* h_file);

extern void errexit (int err, char* s);

extern void logout (FILE* stream, char type, char* str,...);

extern char* word (unsigned char* line, int num);

extern char* wordcpy (char* dest, unsigned char* source, int n);

extern int isaddress( struct sAddr    *addr );

extern struct Slink* islink (struct sAddr* pretend);

extern struct Sarea* isarea (char* pretend);

extern unsigned long crcvalue (char* filename);

extern int wildnicmp (char* wildstr, char* str, int n);

extern int isinlist( char *list, char *item );

#endif
