// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details

#include "dirfile.h"
#include "outbound.h"

char *addr2box(
    char            *boxpath,
    struct sAddr    *addr,
    int             hold )
{
    unsigned short  k;
    char            box32[13], *duotrice="0123456789ABCDEFGHIJKLMNOPQRSTUV";
    k = addr->zone;
    box32[0]=duotrice[(k>>5)&0x1f];
    box32[1]=duotrice[k&0x1f];
    k = addr->net;
    box32[2]=duotrice[(k>>10)&0x1f];
    box32[3]=duotrice[(k>>5)&0x1f];
    box32[4]=duotrice[k&0x1f];
    k = addr->node;
    box32[5]=duotrice[(k>>10)&0x1f];
    box32[6]=duotrice[(k>>5)&0x1f];
    box32[7]=duotrice[k&0x1f];
    k = addr->point;
    box32[8]='.';
    box32[9]=duotrice[(k>>5)&0x1f];
    box32[10]=duotrice[k&0x1f];
    box32[11] = 0;
    if( hold )
    {
        box32[11] = 'H';
        box32[12]=0;
    }
    return strcat( filefull( boxpath, outdir, box32 ), "\\" );
}

int createbox(
    char            *boxpath,
    struct sAddr    *addr,
    int             hold )
{
    return makexist( addr2box( boxpath, addr, hold ) );
}

char *addr2bink(
    char            *binkpath,
    struct sAddr    *addr,
    int             hold )
{
    strcpy( binkpath, outdir );
    if( addr->zone != address[0].zone )
    {
        LASTCHAR( binkpath ) = 0;           // del tailing slash
        sprintf( binkpath, "%s.%03x\\", binkpath, addr->zone );
    }
    sprintf( binkpath, "%s%04x%04x", binkpath, addr->net, addr->node );
    if( addr->point )
    {
        strcat( binkpath, ".pnt" );
        sprintf( binkpath, "%s\\0000%04x", binkpath, addr->point );
    }
    return strcat( binkpath, (hold) ? ".hlo" : ".dlo" );
}

void makebink(
    struct sAddr    *to,
    int             hold,
    char            *filetosend,
    char            *tictosend )
{
    char            binkpath[PATHLEN], drive[DIRLEN], dir[DIRLEN];
    FILE            *Fbink;
    int i;
    _splitpath( addr2bink( binkpath, to, hold ), drive, dir, NULL, NULL );
    if( !makexist( strcat( drive, dir ) ) ) errexit( 2, drive );
    for( i = 0; i < 5; ++i )
        if( Fbink = fopen( binkpath, "at" ) ) break;
        else sleep( 1 );
    if( i == 5 ) errexit( 1, binkpath );
    fprintf( Fbink, "%s\n^%s\n", filetosend, tictosend );
    fclose( Fbink );
}
