#ifndef _FIDOMSG_H
#define _FIDOMSG_H

#include "fidoaddr.h"

struct sMsghdr
{
  char              fromname[36], toname[36], subj[72], datetime[20];
  unsigned short    timesread, tonode, fromnode, cost;
  unsigned short    fromnet, tonet;
  unsigned short    tozone, fromzone, topoint, frompoint;
  unsigned short    replyto, flags, nextreply;
};

struct sMsg
{
    struct sAddr    from, to;
    char            fromname[36], toname[36], subj[72];
    int             isatt, iskil, isdir, iskfs, isrcv, ishld;
    char            *text;
};

extern int readmsg      // -1 if error; DO NOT FORGET to call free(msg.text)!
    (char *msgpath, struct sMsg *msg, unsigned short defaultzone);

extern char* msgtime    // current time in fido-msg format in static string
    (void);

extern int msgtext(     // -1
    struct sMsg *msg,
        char    *path );

extern int writemsg     // -1 if error
    (char *msgdir, struct sMsg *msg);

#endif
