// FILin fileechoprocessor
// Copyright (c) 1995-99 Ilya Bogdanov
// See licence.txt for details


#ifndef _UNIX_
#   include <sys\stat.h>
#else
#   include "posixdir.h"
#endif
#include "general.h"
#include "dirfile.h"
#include "fidomsg.h"
#include "tic.h"
#include "outbound.h"
#include "purge.h"

static struct sTokill tokill[TOKILL];

void purgetics (void)   // purge old tics
{
    struct find_t       fileinfo;
    unsigned            rc;
    char                        filename[PATHLEN];
    int                         k = 0;
    logout( stdout, 0, "  Purging old tics from %s", ticsdir );    
    rc = _dos_findfirst(filefull(filename,ticsdir,"*.tic"),_A_NORMAL,&fileinfo);
    while (rc == 0)
    {
                if (fileage(filefull(filename,ticsdir,fileinfo.name)) >= ticsdays)
        {
                unlink(filename);
            ++k;
        }
        rc = _dos_findnext(&fileinfo);
        }
    _dos_findclose(&fileinfo);
    if( k ) logout( stdout, 0, "  %d old tics purged", k );
}

int loadtokill( void )   // returns the number of loaded tokill[]
{
    unsigned    done;
    struct      find_t f;
    struct      Slink *link;
    int         i, k = 0;
    struct      Sarea *area;
    done = _dos_findfirst( filefull( ticfull, outb, "*.tic" ), _A_NORMAL, &f );
    while( !done )
    {
        filefull( ticfull, outb, f.name );
        load_tic();
        if( ( link = islink( &in.to ) ) && link->days && ( area = isarea( in.area ) ) )
        {
            if( fileage( ticfull ) >= link->days )
            {
                tokill[k].link = link;
                tokill[k].area = area;
                strcpy( tokill[k].tic, ticfull );
                if( *area->dir )
                    strcpy( tokill[k].file, area->dir );
                else
                    strcpy( tokill[k].file, outb );
                strcat( tokill[k].file, in.file );
                if( ++k == TOKILL ) break;                         // no more then TOKILL
            }
        }
        done = _dos_findnext( &f );
    }
    _dos_findclose( &f );
    for( i = 0; i < k; i++ )
    {
        unlink( tokill[i].tic );
        logout( NULL, '*', "%s purged", tokill[i].tic );
    }
    if( k ) logout( stdout, 0, "  %d tics purged from outbound", k );
    return k;
}

void killama
        (int k)
{
    struct find_t       f;
    unsigned            done;
    char                        msgpath[PATHLEN];
    struct sMsg         msg;
    int                         i;
    struct Slink        *downlink;
    if (k < 1) return;                  // nothing to kill
    done = _dos_findfirst(filefull(msgpath,outmaildir,"*.msg"),_A_NORMAL,&f);
        while (!done)
        {
        if (readmsg(filefull(msgpath,outmaildir,f.name),&msg,la.zone) != -1)
        {
                if (stricmp(msg.fromname,"FILin") == 0 && msg.isatt)
            {
                for (i = 0; i < 10 && !addrcmp(&address[i],&msg.from); i++);
                if (i < 10 && (downlink = islink(&msg.to)))             // from & to
                        for (i = 0; i < k; i++)                     // tokill
                        if (downlink == tokill[i].link
                                && ((stricmp(msg.subj,tokill[i].tic) == 0)
                             || (stricmp(msg.subj,tokill[i].file) == 0)))
                        {
                            unlink( msgpath );
                            logout( NULL, '*', "%s deleted", msgpath );
                                break;
                        }
            }
                free(msg.text);
        }
                done = _dos_findnext(&f);
        }
        _dos_findclose(&f);
}

void killbso(
    int     k )
{
    char    binkpath[PATHLEN], temppath[PATHLEN], buf[PATHLEN + 2]; // ^path\n
    FILE    *F, *T;
    int     x = -1, j, i = 0;
    if( k < 1 ) return;                 // nothing to kill
    while( i < k )
    {
        if( F = fopen( addr2bink( binkpath, &tokill[i].link->addr, tokill[i].link->hold ), "r+t" ) )
        {
            strcpy( strchr( strcpy( temppath, binkpath ), 0 ) - 3, "fln" );
            if( !( T = fopen( temppath, "w+t" ) ) ) errexit( 1, temppath );
            while( fgets( buf, PATHLEN + 2, F ) )
            {
                if( LASTCHAR( buf ) == '\n' ) LASTCHAR( buf ) = 0;
                for( j = i; j < k
                        && ( tokill[j].link != tokill[i].link || stricmp( buf, tokill[j].file )
                        && stricmp( buf + 1, tokill[j].tic ) ); j++ );
                if( j == k ) x = fputs( strcat( buf, "\n" ), T );
            }
            fclose( T );
            fclose( F );
            unlink( binkpath );
                        if( x < 0 ) unlink( temppath );
            else rename( temppath, binkpath );
        }
        do
        {
                ++i;
                for( j = 0; j < i && tokill[j].link != tokill[i].link; j++ );
        }
        while( j < i && i < k );
    }
}

int killbox( void )
{
        // for all links do: if it has %days then find its box, look for old tics,
        // look into for files, load tokill[], delete both
    struct Slink        *Ltemp = links;
    unsigned            done;
    int                         i, k = 0;
    char                        boxpath[PATHLEN];
    struct find_t       f;
    struct Sarea        *area;
    while( Ltemp )
    {
        if( Ltemp->days )
        {
                done = _dos_findfirst(
                filefull( ticfull, addr2box( boxpath, &Ltemp->addr, 0 ),
                        "*.tic" ), _A_NORMAL, &f );
                while( !done )
            {
                        filefull( ticfull, boxpath, f.name );
                if( fileage( ticfull ) >= Ltemp->days )
                {
                        load_tic();                                                     // load 'in'
                        if( area = isarea( in.area ) )
                    {
                        tokill[k].link = Ltemp;
                                tokill[k].area = area;
                                strcpy( tokill[k].tic, ticfull );
                        filefull( tokill[k].file, boxpath, in.file );
                                ++k;
                                if (k == TOKILL) break;                 // no more then TOKILL
                    }
                }
                done = _dos_findnext( &f );
            }
            _dos_findclose( &f );
        }
        Ltemp = Ltemp->next;
    }
    for( i = 0; i < k; i++ )
    {
        unlink( tokill[i].tic );
        logout( NULL, '*', "%s purged\n", tokill[i].tic );
        unlink( tokill[i].file );
        logout( NULL, '*', "%s purged\n", tokill[i].file );
        }
    return k;
}

void divideRpt(
        char    *rpt,
    char        **body,
    char        **tail )
{
    if( ( *body = strchr( rpt, '<' ) ) == NULL ) *tail = NULL;
    else
        if( ( *tail = strchr( *body, '>' ) ) == NULL ) *body = NULL;
        else
        {
                *(*body)++ = 0; 
                *(*tail)++ = 0;
        }
}

void rpt2text(
        char            *rpt,
    char                *body,
    char                *tail,
    int                 i,
    int                 k,
    struct sMsg *msg )
{
    char                *p;
    FILE                *f;
    long                size;
    int                 j;
    f = tmpfile();
    fwrite( rpt, strlen( rpt ), 1, f );
        for( j = k - 1; j >= i; --j )
    {
                if( tokill[j].link == tokill[i].link )
        {
            if( p = body )
            {
                while( rpt = strchr( p, '@' ) )
                {
                        fwrite( p, rpt - p, 1, f );
                        switch( *( rpt + 1 ) )
                        {
                                case 'F':
                            p = strrchr( tokill[j].file, SLASHC );
                            fwrite( p + 1 , strlen( p + 1 ), 1, f );
                                break;
                        case 'A':
                                fwrite( tokill[j].area->tag,
                                        strlen( tokill[j].area->tag ), 1, f );
                                break;
                        }
                        p = rpt + 2;
                }
                fwrite( p, strlen( p ), 1, f );
            }
            tokill[j].link = NULL;
        }
    }
    if( tail ) fwrite( tail, strlen( tail ), 1, f );
    msg->text = ( char * ) malloc( ( size = ftell( f ) ) + 1 ); // \0
        fseek( f, 0L, SEEK_SET );
    fread( msg->text, size, 1, f );
    msg->text[ size ] = 0;
    fclose( f );
}

void purgerpt(
        int             k )
{
        int             i;
    struct sMsg msg = { { 0, 0, 0, 0 }, { 0, 0, 0, 0},
                                        "FILin", "SysOp", "PURGE report", 0, 0, 0, 0, NULL };
    FILE                *f;
    struct stat st;
    char                *rpt, *body, *tail;
    msg.iskil = !( mgropt & 4 );
    msg.isdir = mgropt & 8;
    if( stat( "purge.rpt", &st ) == -1 ) return;
    rpt = ( char * ) malloc( st.st_size + 1 );          // \0
    f = fopen( "purge.rpt", "rb" );
    fread( rpt, st.st_size, 1, f );
    fclose( f );
    rpt[ st.st_size ] = 0;
    divideRpt( rpt, &body, &tail );
    for( i = 0; i < k; ++i )
    {
        if( tokill[i].link != NULL )
        {
            msg.from = address[tokill[i].area->aka];
            msg.to = tokill[i].link->addr;
            rpt2text( rpt, body, tail, i, k, &msg );
            if( writemsg( outmaildir, &msg ) == -1 )
                logout( stdout, '?', "Report failed" );
            else
                logout( NULL, '*', "PURGE report sent to %s",
                        addrtostr ( &msg.to ) );
        }
    }
}

void kill( void )
{
    int k = 0;
    logout( stdout, 0, "  FileEchoSaw" );
    switch( outtype )
    {
        case AMA: killama( k = loadtokill() ); break;
        case BSO: killbso( k = loadtokill() ); break;
        case BOX: k = killbox(); break;
    }
    if( k ) purgerpt( k );
}

void purgeoutb( void )
{
    unsigned    done;
    struct      find_t f;
    char        path[PATHLEN], line[TICLINE];
    struct      sTopurge *topurge, *chaintopurge = NULL;
    FILE        *tic;
    logout( stdout, 0, "  Purging sent passthru files", f.name );    
    done = _dos_findfirst( filefull( path, outb, "*.tic" ), _A_NORMAL, &f );
    while( !done )
    {
        if( !chaintopurge )
            topurge = chaintopurge = NEW( struct sTopurge );
        else
            topurge = topurge->next = NEW( struct sTopurge );
        if( !( tic = fopen( filefull( path, outb, f.name ), "rt" ) ) ) errexit( 1, path );
        while( fgets( line, TICLINE, tic ) && strnicmp( line, "File ", 5 ) );
        wordcpy( topurge->filename, word( line, 1 ), FILELEN );
        fclose( tic );
        done = _dos_findnext( &f );
    }
    _dos_findclose( &f );
    done = _dos_findfirst( filefull( path, outb, "*.*" ), _A_NORMAL, &f );
    while( !done )
    {
        if( stricmp( strchr( f.name, 0 ) - 4, ".tic" ) )         // file.tic* also matches
        {
            for( topurge = chaintopurge;
                topurge && stricmp( f.name, topurge->filename );
                topurge = topurge->next );
            if( !topurge )
            {
                unlink( filefull( path, outb, f.name ) );
                logout( NULL, '*', " %s purged", f.name );
            }
        }
        done = _dos_findnext( &f );
    }
    _dos_findclose( &f );
}

void purge( void )
{
    kill();                         // fileechosaw
    purgeoutb();                    // sent passthru
    if( ticsdays > 0 ) purgetics(); // old tics
}
